function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { filterHelper, filterHelperArgs } from './helpers';
export default function distinct(model, // === MongooseModel
tc, opts) {
  if (!model || !model.modelName || !model.schema) {
    throw new Error('First arg for Resolver distinct() should be instance of Mongoose Model.');
  }

  if (!tc || tc.constructor.name !== 'ObjectTypeComposer') {
    throw new Error('Second arg for Resolver distinct() should be instance of ObjectTypeComposer.');
  }

  return tc.schemaComposer.createResolver({
    type: '[String]',
    name: 'distinct',
    kind: 'query',
    args: _objectSpread({
      field: 'String!'
    }, filterHelperArgs(tc, model, _objectSpread({
      filterTypeName: `FilterDistinct${tc.getTypeName()}Input`,
      model
    }, opts && opts.filter))),
    resolve: resolveParams => {
      const {
        field
      } = resolveParams.args;
      resolveParams.query = model.distinct(field, {}); // eslint-disable-line

      filterHelper(resolveParams);
      return resolveParams.query.exec();
    }
  });
}